import os
import tempfile
import time
import string

def check_prereqs():
    if not os.path.isfile("plink.exe"):
        raise NameError, "plink.exe not found.  pix_scrape can not function"
    if not os.path.isdir("pix_scrape_tmp"):
        raise NameError, "tmp directory not found.  pix_scrape can not function"
    
def scrape( hostname, username, password, commands, port=22, v="ssh2"):

    check_prereqs()

    f = tempfile.NamedTemporaryFile(delete=False, dir="pix_scrape_tmp")
    filename = f.name

    print " *** writing commands to temporary file: ", filename
    print " *** Note!  For some reason, plink doesn't like this file in cygwin.  Use cmd, Eli!"
    print " *** Note!  While we're at it, remember that key-acceptance is not scriptable, so you have to log in to each unit manually once before using this script!"
    for each in commands:
        f.write("%s\n" % each)
    f.close()

    #time.sleep(2)

    if v == "ssh2":
        vstring = "-ssh -2"
    elif v == "ssh1":
        vstring = "-ssh -1"
    elif v == "telnet":
        vstring = "-telnet"
    else:
        raise NameError, "invalid version string specified: %s" % (v)
    
    cmd = "plink.exe " + vstring + " -batch -v -l " + username + " -pw " + password + " -m \"" + filename + "\" " + hostname

    #print cmd

    print " *** executing command: ", cmd
    put,get = os.popen4(cmd)

    had_to_abort = False

    buffer = []
    linecount = 0
    for line in get.readlines():
        buffer.append(line)
        if linecount < 20:
            print " *** ", line ,
        elif linecount == 20:
            print " *** Only first 20 lines shown *** "
        linecount = linecount + 1

        #if string.find(line, "Connection Abandoned.") > 0:
        if line.find("Connection abandoned") > -1:
            #this happens if the key isn't cashed in the registry
            had_to_abort = True

    
    print " *** overwriting temporary file: ", filename
    # blow away the temporary file
    f = open(filename, 'w')
    f.write( "Gibberish" * 100 + ".  Wow that was a mouthful!!")
    f.close()

    #time.sleep(2)
    print " *** removing temporary file: ", filename
    os.remove(filename)

    if had_to_abort == True:
        raise NameError, "You need to connect to the device first once via normal putty so its host key will be cached in your registry"

    return buffer

